<?php

namespace common\logic\PointSale\PointSale;

use common\logic\BaseService;
use common\logic\BuilderInterface;
use common\logic\Order\Order\Order;
use common\logic\SolverInterface;

class PointSaleBuilder extends BaseService implements BuilderInterface
{
    public function instanciate(): PointSale
    {
        $pointSale = new PointSale();

        return $pointSale;
    }

    /**
     * Initialise les commandes liées au point de vente.
     */
    public function initOrders(PointSale $pointSale, array $ordersArray): void
    {
        $pointSale->orders = [];
        $pointSale->revenues = 0;
        $pointSale->revenues_with_tax = 0;

        if ($ordersArray) {
            foreach ($ordersArray as $order) {
                if ($pointSale->id == $order->id_point_sale) {
                    $pointSale->orders[] = $order;

                    if (is_null($order->date_delete)) {
                        $pointSale->revenues += (float) $order->amount;
                        $pointSale->revenues_with_tax += (float) $order->amount_with_tax;
                    }
                }
            }
        }
    }
}